diff --git a/gcc/cp/decl.c b/gcc/cp/decl.c
index 4eb3e69..a470951 100644
--- a/gcc/cp/decl.c
+++ b/gcc/cp/decl.c
@@ -619,10 +619,10 @@ poplevel (int keep, int reverse, int functionbody)
      ended.  We only use the new rules if flag_new_for_scope is
      nonzero.  */
   leaving_for_scope
-    = current_binding_level->kind == sk_for && flag_new_for_scope == 1;
+    = current_binding_level->kind == sk_for && GCC_OPTION (flag_new_for_scope) == 1;
 
   /* Before we remove the declarations first check for unused variables.  */
-  if ((warn_unused_variable || warn_unused_but_set_variable)
+  if ((GCC_OPTION (warn_unused_variable) || GCC_OPTION (warn_unused_but_set_variable))
       && !processing_template_decl)
     for (tree d = getdecls (); d; d = TREE_CHAIN (d))
       {
@@ -1183,9 +1183,9 @@ check_redeclaration_exception_specification (tree new_decl,
      all declarations, including the definition and an explicit
      specialization, of that function shall have an
      exception-specification with the same set of type-ids.  */
-  if ((pedantic || ! DECL_IN_SYSTEM_HEADER (old_decl))
+  if ((GCC_OPTION (pedantic) || ! DECL_IN_SYSTEM_HEADER (old_decl))
       && ! DECL_IS_BUILTIN (old_decl)
-      && flag_exceptions
+      && GCC_OPTION (flag_exceptions)
       && !comp_except_specs (new_exceptions, old_exceptions, ce_normal))
     {
       error ("declaration of %qF has a different exception specifier",
@@ -1798,7 +1798,7 @@ duplicate_decls (tree newdecl, tree olddecl, bool newdecl_is_friend)
       /* Optionally warn about more than one declaration for the same
 	 name, but don't warn about a function declaration followed by a
 	 definition.  */
-      if (warn_redundant_decls && ! DECL_ARTIFICIAL (olddecl)
+      if (GCC_OPTION (warn_redundant_decls) && ! DECL_ARTIFICIAL (olddecl)
 	  && !(new_defines_function && DECL_INITIAL (olddecl) == NULL_TREE)
 	  /* Don't warn about extern decl followed by definition.  */
 	  && !(DECL_EXTERNAL (olddecl) && ! DECL_EXTERNAL (newdecl))
@@ -2976,7 +2976,7 @@ check_goto (tree decl)
 
   if (ent->in_omp_scope)
     error ("  enters OpenMP structured block");
-  else if (flag_openmp)
+  else if (GCC_OPTION (flag_openmp))
     {
       cp_binding_level *b;
       for (b = current_binding_level; b ; b = b->level_chain)
@@ -3714,8 +3714,8 @@ cxx_init_decl_processing (void)
   TREE_PUBLIC (global_namespace) = 1;
   begin_scope (sk_namespace, global_namespace);
 
-  if (flag_visibility_ms_compat)
-    default_visibility = VISIBILITY_HIDDEN;
+  if (GCC_OPTION (flag_visibility_ms_compat))
+    GCC_OPTION (default_visibility) = VISIBILITY_HIDDEN;
 
   /* Initially, C.  */
   current_lang_name = lang_name_c;
@@ -3872,17 +3872,17 @@ cxx_init_decl_processing (void)
   init_rtti_processing ();
   init_template_processing ();
 
-  if (flag_exceptions)
+  if (GCC_OPTION (flag_exceptions))
     init_exception_processing ();
 
   if (! supports_one_only ())
-    flag_weak = 0;
+    GCC_OPTION (flag_weak) = 0;
 
   make_fname_decl = cp_make_fname_decl;
   start_fname_decls ();
 
   /* Show we use EH for cleanups.  */
-  if (flag_exceptions)
+  if (GCC_OPTION (flag_exceptions))
     using_eh_for_cleanups ();
 }
 
@@ -4132,7 +4132,7 @@ push_cp_library_fn (enum tree_code operator_code, tree type,
 				 operator_code,
 				 type, ecf_flags);
   pushdecl (fn);
-  if (flag_tm)
+  if (GCC_OPTION (flag_tm))
     apply_tm_attr (fn, get_identifier ("transaction_safe"));
   return fn;
 }
@@ -4356,7 +4356,7 @@ check_tag_decl (cp_decl_specifier_seq *declspecs,
         error ("%<constexpr%> cannot be used for type declarations");
     }
 
-  if (declspecs->attributes && warn_attributes && declared_type)
+  if (declspecs->attributes && GCC_OPTION (warn_attributes) && declared_type)
     {
       location_t loc;
       if (!CLASS_TYPE_P (declared_type)
@@ -4908,7 +4908,7 @@ maybe_deduce_size_from_array_init (tree decl, tree init)
 		 well as static, so it does not get allocated.  If it's not
 		 `static', then don't mark it extern; finish_incomplete_decl
 		 will give it a default size and it will get allocated.  */
-	      else if (!pedantic && TREE_STATIC (decl) && !TREE_PUBLIC (decl))
+	      else if (!GCC_OPTION (pedantic) && TREE_STATIC (decl) && !TREE_PUBLIC (decl))
 		DECL_EXTERNAL (decl) = 1;
 	    }
 	  else if (failure == 3)
@@ -4999,7 +4999,7 @@ maybe_commonize_var (tree decl)
       && DECL_FUNCTION_SCOPE_P (decl)
       && vague_linkage_p (DECL_CONTEXT (decl)))
     {
-      if (flag_weak)
+      if (GCC_OPTION (flag_weak))
 	{
 	  /* With weak symbols, we simply make the variable COMDAT;
 	     that will cause copies in multiple translations units to
@@ -5775,7 +5775,7 @@ check_initializer (tree decl, tree init, int flags, vec<tree, va_gc> **cleanups)
 
 	  init_code = store_init_value (decl, init, cleanups, flags);
 
-	  if (pedantic && TREE_CODE (type) == ARRAY_TYPE
+	  if (GCC_OPTION (pedantic) && TREE_CODE (type) == ARRAY_TYPE
 	      && DECL_INITIAL (decl)
 	      && TREE_CODE (DECL_INITIAL (decl)) == STRING_CST
 	      && PAREN_STRING_LITERAL_P (DECL_INITIAL (decl)))
@@ -6583,7 +6583,7 @@ get_atexit_fn_ptr_type (void)
   if (!atexit_fn_ptr_type_node)
     {
       tree arg_type;
-      if (flag_use_cxa_atexit 
+      if (GCC_OPTION (flag_use_cxa_atexit) 
 	  && !targetm.cxx.use_atexit_for_cxa_atexit ())
 	/* The parameter to "__cxa_atexit" is "void (*)(void *)".  */
 	arg_type = ptr_type_node;
@@ -6615,7 +6615,7 @@ get_atexit_node (void)
   if (atexit_node)
     return atexit_node;
 
-  if (flag_use_cxa_atexit && !targetm.cxx.use_atexit_for_cxa_atexit ())
+  if (GCC_OPTION (flag_use_cxa_atexit) && !targetm.cxx.use_atexit_for_cxa_atexit ())
     {
       /* The declaration for `__cxa_atexit' is:
 
@@ -6728,7 +6728,7 @@ start_cleanup_fn (void)
   char name[32];
   tree fntype;
   tree fndecl;
-  bool use_cxa_atexit = flag_use_cxa_atexit
+  bool use_cxa_atexit = GCC_OPTION (flag_use_cxa_atexit)
 			&& !targetm.cxx.use_atexit_for_cxa_atexit ();
 
   push_to_top_level ();
@@ -6804,7 +6804,7 @@ register_dtor_fn (tree decl)
      "__aeabi_atexit"), and DECL is a class object, we can just pass the
      destructor to "__cxa_atexit"; we don't have to build a temporary
      function to do the cleanup.  */
-  dso_parm = (flag_use_cxa_atexit
+  dso_parm = (GCC_OPTION (flag_use_cxa_atexit)
 	      && !targetm.cxx.use_atexit_for_cxa_atexit ());
   ob_parm = (DECL_THREAD_LOCAL_P (decl) || dso_parm);
   use_dtor = ob_parm && CLASS_TYPE_P (type);
@@ -6957,7 +6957,7 @@ expand_static_init (tree decl, tree init)
       tree guard, guard_addr;
       tree flag, begin;
       /* We don't need thread-safety code for thread-local vars.  */
-      bool thread_guard = (flag_threadsafe_statics
+      bool thread_guard = (GCC_OPTION (flag_threadsafe_statics)
 			   && !DECL_THREAD_LOCAL_P (decl));
 
       /* Emit code to perform this initialization but once.  This code
@@ -7167,10 +7167,10 @@ cp_complete_array_type_or_error (tree *ptype, tree initial_value,
   bool sfinae = !(complain & tf_error);
   /* In SFINAE context we can't be lenient about zero-size arrays.  */
   if (sfinae)
-    ++pedantic;
+    ++GCC_OPTION (pedantic);
   failure = cp_complete_array_type (ptype, initial_value, do_default);
   if (sfinae)
-    --pedantic;
+    --GCC_OPTION (pedantic);
   if (failure)
     {
       if (sfinae)
@@ -7658,7 +7658,7 @@ grokfndecl (tree ctype,
   if (TYPE_NOTHROW_P (type) || nothrow_libfn_p (decl))
     TREE_NOTHROW (decl) = 1;
 
-  if (flag_openmp || flag_cilkplus)
+  if (GCC_OPTION (flag_openmp) || GCC_OPTION (flag_cilkplus))
     {
       /* Adjust "omp declare simd" attributes.  */
       tree ods = lookup_attribute ("omp declare simd", *attrlist);
@@ -7727,7 +7727,7 @@ grokfndecl (tree ctype,
 	  newtype = build_function_type (integer_type_node, oldtypeargs);
 	  TREE_TYPE (decl) = newtype;
 	}
-      if (warn_main)
+      if (GCC_OPTION (warn_main))
 	check_main_parameter_types (decl);
     }
 
@@ -8326,14 +8326,14 @@ compute_array_index_type (tree name, tree size, tsubst_flags_t complain)
 	error ("size of array is not an integral constant-expression");
       size = integer_one_node;
     }
-  else if (cxx_dialect < cxx1y && pedantic && warn_vla != 0)
+  else if (cxx_dialect < cxx1y && GCC_OPTION (pedantic) && GCC_OPTION (warn_vla) != 0)
     {
       if (name)
 	pedwarn (input_location, OPT_Wvla, "ISO C++ forbids variable length array %qD", name);
       else
 	pedwarn (input_location, OPT_Wvla, "ISO C++ forbids variable length array");
     }
-  else if (warn_vla > 0)
+  else if (GCC_OPTION (warn_vla) > 0)
     {
       if (name)
 	warning (OPT_Wvla, 
@@ -8384,7 +8384,7 @@ compute_array_index_type (tree name, tree size, tsubst_flags_t complain)
 
 	  stabilize_vla_size (itype);
 
-	  if (cxx_dialect >= cxx1y && flag_exceptions)
+	  if (cxx_dialect >= cxx1y && GCC_OPTION (flag_exceptions))
 	    {
 	      /* If the VLA bound is larger than half the address space,
 	         or less than zero, throw std::bad_array_length.  */
@@ -8394,7 +8394,7 @@ compute_array_index_type (tree name, tree size, tsubst_flags_t complain)
 			     throw_bad_array_length (), void_zero_node);
 	      finish_expr_stmt (comp);
 	    }
-	  else if (flag_sanitize & SANITIZE_VLA)
+	  else if (GCC_OPTION (flag_sanitize) & SANITIZE_VLA)
 	    {
 	      /* From C++1y onwards, we throw an exception on a negative
 		 length size of an array; see above.  */
@@ -8473,7 +8473,7 @@ create_array_type_for_decl (tree name, tree type, tree size)
 
   /* 8.3.4/1: If the type of the identifier of D contains the auto
      type-specifier, the program is ill-formed.  */
-  if (pedantic && type_uses_auto (type))
+  if (GCC_OPTION (pedantic) && type_uses_auto (type))
     pedwarn (input_location, OPT_Wpedantic,
 	     "declaration of %qD as array of %<auto%>", name);
 
@@ -8531,7 +8531,7 @@ create_array_type_for_decl (tree name, tree type, tree size)
     }
 
   if (cxx_dialect >= cxx1y && array_of_runtime_bound_p (type)
-      && (flag_iso || warn_vla > 0))
+      && (flag_iso || GCC_OPTION (warn_vla) > 0))
     pedwarn (input_location, OPT_Wvla, "array of array of runtime bound");
 
   /* Figure out the index type for the array.  */
@@ -9072,11 +9072,11 @@ grokdeclarator (const cp_declarator *declarator,
 
       if (type_was_error_mark_node)
 	/* We've already issued an error, don't complain more.  */;
-      else if (in_system_header_at (input_location) || flag_ms_extensions)
+      else if (in_system_header_at (input_location) || GCC_OPTION (flag_ms_extensions))
 	/* Allow it, sigh.  */;
       else if (! is_main)
 	permerror (input_location, "ISO C++ forbids declaration of %qs with no type", name);
-      else if (pedantic)
+      else if (GCC_OPTION (pedantic))
 	pedwarn (input_location, OPT_Wpedantic,
 		 "ISO C++ forbids declaration of %qs with no type", name);
       else
@@ -9095,7 +9095,7 @@ grokdeclarator (const cp_declarator *declarator,
 	  error ("%<__int128%> is not supported by this target");
 	  explicit_int128 = false;
 	}
-      else if (pedantic && ! in_system_header_at (input_location))
+      else if (GCC_OPTION (pedantic) && ! in_system_header_at (input_location))
 	pedwarn (input_location, OPT_Wpedantic,
 		 "ISO C++ does not support %<__int128%> for %qs", name);
     }
@@ -9145,12 +9145,12 @@ grokdeclarator (const cp_declarator *declarator,
       else
 	{
 	  ok = 1;
-	  if (!explicit_int && !defaulted_int && !explicit_char && !explicit_int128 && pedantic)
+	  if (!explicit_int && !defaulted_int && !explicit_char && !explicit_int128 && GCC_OPTION (pedantic))
 	    {
 	      pedwarn (input_location, OPT_Wpedantic, 
 		       "long, short, signed or unsigned used invalidly for %qs",
 		       name);
-	      if (flag_pedantic_errors)
+	      if (GCC_OPTION (flag_pedantic_errors))
 		ok = 0;
 	    }
 	}
@@ -9177,7 +9177,7 @@ grokdeclarator (const cp_declarator *declarator,
 
 	 Naturally, we extend this to long long as well.  Note that
 	 this does not include wchar_t.  */
-      || (bitfield && !flag_signed_bitfields
+      || (bitfield && !GCC_OPTION (flag_signed_bitfields)
 	  && !signed_p
 	  /* A typedef for plain `int' without `signed' can be
 	     controlled just like plain `int', but a typedef for
@@ -9764,7 +9764,7 @@ grokdeclarator (const cp_declarator *declarator,
 		   type);
 
 	  if (cxx_dialect >= cxx1y && array_of_runtime_bound_p (type)
-	      && (flag_iso || warn_vla > 0))
+	      && (flag_iso || GCC_OPTION (warn_vla) > 0))
 	    pedwarn (input_location, OPT_Wvla,
 		     declarator->kind == cdk_reference
 		     ? G_("reference to array of runtime bound")
@@ -10113,7 +10113,7 @@ grokdeclarator (const cp_declarator *declarator,
 	}
 
       if (cxx_dialect >= cxx1y && array_of_runtime_bound_p (type)
-	  && (flag_iso || warn_vla > 0))
+	  && (flag_iso || GCC_OPTION (warn_vla) > 0))
 	pedwarn (input_location, OPT_Wvla,
 		 "typedef naming array of runtime bound");
 
@@ -10698,7 +10698,7 @@ grokdeclarator (const cp_declarator *declarator,
 	if (! toplevel_bindings_p ()
 	    && (storage_class == sc_static
 		|| decl_spec_seq_has_spec_p (declspecs, ds_inline))
-	    && pedantic)
+	    && GCC_OPTION (pedantic))
 	  {
 	    if (storage_class == sc_static)
 	      pedwarn (input_location, OPT_Wpedantic, 
@@ -10796,7 +10796,7 @@ grokdeclarator (const cp_declarator *declarator,
 		error ("static member %qD declared %<register%>", decl);
 		storage_class = sc_none;
 	      }
-	    if (storage_class == sc_extern && pedantic)
+	    if (storage_class == sc_extern && GCC_OPTION (pedantic))
 	      {
 		pedwarn (input_location, OPT_Wpedantic, 
 			 "cannot explicitly declare member %q#D to have "
@@ -10951,7 +10951,7 @@ check_default_argument (tree decl, tree arg, tsubst_flags_t complain)
 				     LOOKUP_IMPLICIT);
   --cp_unevaluated_operand;
 
-  if (warn_zero_as_null_pointer_constant
+  if (GCC_OPTION (warn_zero_as_null_pointer_constant)
       && TYPE_PTR_OR_PTRMEM_P (decl_type)
       && null_ptr_cst_p (arg)
       && (complain & tf_warning)
@@ -11571,7 +11571,7 @@ grok_op_properties (tree decl, bool complain)
       /* Warn about conversion operators that will never be used.  */
       if (IDENTIFIER_TYPENAME_P (name)
 	  && ! DECL_TEMPLATE_INFO (decl)
-	  && warn_conversion
+	  && GCC_OPTION (warn_conversion)
 	  /* Warn only declaring the function; there is no need to
 	     warn again about out-of-class definitions.  */
 	  && class_type == current_class_type)
@@ -11689,7 +11689,7 @@ grok_op_properties (tree decl, bool complain)
 	    }
 
 	  /* More Effective C++ rule 6.  */
-	  if (warn_ecpp
+	  if (GCC_OPTION (warn_ecpp)
 	      && (operator_code == POSTINCREMENT_EXPR
 		  || operator_code == POSTDECREMENT_EXPR
 		  || operator_code == PREINCREMENT_EXPR
@@ -11739,7 +11739,7 @@ grok_op_properties (tree decl, bool complain)
 	    }
 
 	  /* More Effective C++ rule 7.  */
-	  if (warn_ecpp
+	  if (GCC_OPTION (warn_ecpp)
 	      && (operator_code == TRUTH_ANDIF_EXPR
 		  || operator_code == TRUTH_ORIF_EXPR
 		  || operator_code == COMPOUND_EXPR))
@@ -11748,7 +11748,7 @@ grok_op_properties (tree decl, bool complain)
 	}
 
       /* Effective C++ rule 23.  */
-      if (warn_ecpp
+      if (GCC_OPTION (warn_ecpp)
 	  && arity == 2
 	  && !DECL_ASSIGNMENT_OPERATOR_P (decl)
 	  && (operator_code == PLUS_EXPR
@@ -12661,7 +12661,7 @@ finish_enum_value_list (tree enumtype)
          user can request that for all enumerations with a command line
          flag, or for just one enumeration with an attribute.  */
 
-      use_short_enum = flag_short_enums
+      use_short_enum = GCC_OPTION (flag_short_enums)
         || lookup_attribute ("packed", TYPE_ATTRIBUTES (enumtype));
 
       for (itk = (use_short_enum ? itk_char : itk_int);
@@ -12721,7 +12721,7 @@ finish_enum_value_list (tree enumtype)
         (ENUM_UNDERLYING_TYPE (enumtype), precision, unsignedp);
 
       /* If -fstrict-enums, still constrain TYPE_MIN/MAX_VALUE.  */
-      if (flag_strict_enums)
+      if (GCC_OPTION (flag_strict_enums))
 	set_min_and_max_values_for_integral_type (enumtype, precision,
 						  unsignedp);
     }
@@ -13112,7 +13112,7 @@ start_preparsed_function (tree decl1, tree attrs, int flags)
     maybe_begin_member_template_processing (decl1);
 
   /* Effective C++ rule 15.  */
-  if (warn_ecpp
+  if (GCC_OPTION (warn_ecpp)
       && DECL_OVERLOADED_OPERATOR_P (decl1) == NOP_EXPR
       && VOID_TYPE_P (TREE_TYPE (fntype)))
     warning (OPT_Weffc__, "%<operator=%> should return a reference to %<*this%>");
@@ -13194,7 +13194,7 @@ start_preparsed_function (tree decl1, tree attrs, int flags)
 	      /* Otherwise, OLDDECL is either a previous declaration
 		 of the same function or DECL1 itself.  */
 
-	      if (warn_missing_declarations
+	      if (GCC_OPTION (warn_missing_declarations)
 		  && olddecl == decl1
 		  && !DECL_MAIN_P (decl1)
 		  && TREE_PUBLIC (decl1)
@@ -13345,7 +13345,7 @@ start_preparsed_function (tree decl1, tree attrs, int flags)
 	  DECL_EXTERNAL (decl1)
 	    = (finfo->interface_only
 	       || (DECL_DECLARED_INLINE_P (decl1)
-		   && ! flag_implement_inlines
+		   && ! GCC_OPTION (flag_implement_inlines)
 		   && !DECL_VINDEX (decl1)));
 
 	  /* For WIN32 we also want to put these in linkonce sections.  */
@@ -13457,7 +13457,7 @@ start_function (cp_decl_specifier_seq *declspecs,
 static bool
 use_eh_spec_block (tree fn)
 {
-  return (flag_exceptions && flag_enforce_eh_specs
+  return (GCC_OPTION (flag_exceptions) && GCC_OPTION (flag_enforce_eh_specs)
 	  && !processing_template_decl
 	  && !type_throw_all_p (TREE_TYPE (fn))
 	  /* We insert the EH_SPEC_BLOCK only in the original
@@ -13856,7 +13856,7 @@ finish_function (int flags)
   /* If this function can't throw any exceptions, remember that.  */
   if (!processing_template_decl
       && !cp_function_chain->can_throw
-      && !flag_non_call_exceptions
+      && !GCC_OPTION (flag_non_call_exceptions)
       && !decl_replaceable_p (fndecl))
     TREE_NOTHROW (fndecl) = 1;
 
@@ -13950,7 +13950,7 @@ finish_function (int flags)
     save_function_data (fndecl);
 
   /* Complain if there's just no return statement.  */
-  if (warn_return_type
+  if (GCC_OPTION (warn_return_type)
       && !VOID_TYPE_P (TREE_TYPE (fntype))
       && !dependent_type_p (TREE_TYPE (fntype))
       && !current_function_returns_value && !current_function_returns_null
@@ -13977,7 +13977,7 @@ finish_function (int flags)
   cfun->function_end_locus = input_location;
 
   /* Complain about parameters that are only set, but never otherwise used.  */
-  if (warn_unused_but_set_parameter
+  if (GCC_OPTION (warn_unused_but_set_parameter)
       && !processing_template_decl
       && errorcount == unused_but_set_errorcount
       && !DECL_CLONED_FUNCTION_P (fndecl))
diff --git a/gcc/cp/decl2.c b/gcc/cp/decl2.c
index dfc532d..7b596cd 100644
--- a/gcc/cp/decl2.c
+++ b/gcc/cp/decl2.c
@@ -1131,7 +1131,7 @@ is_late_template_attribute (tree attr, tree decl)
     return false;
 
   /* #pragma omp declare simd attribute needs to be always deferred.  */
-  if (flag_openmp
+  if (GCC_OPTION (flag_openmp)
       && is_attribute_p ("omp declare simd", name))
     return true;
 
@@ -1700,7 +1700,7 @@ mark_vtable_entries (tree decl)
 void
 comdat_linkage (tree decl)
 {
-  if (flag_weak)
+  if (GCC_OPTION (flag_weak))
     make_decl_one_only (decl, cxx_comdat_group (decl));
   else if (TREE_CODE (decl) == FUNCTION_DECL
 	   || (VAR_P (decl) && DECL_ARTIFICIAL (decl)))
@@ -1760,7 +1760,7 @@ maybe_make_one_only (tree decl)
      after a weak one is an error.  Also, not making explicit
      instantiations one_only means that we can end up with two copies of
      some template instantiations.  */
-  if (! flag_weak)
+  if (! GCC_OPTION (flag_weak))
     return;
 
   /* We can't set DECL_COMDAT on functions, or cp_finish_file will think
@@ -1835,7 +1835,7 @@ import_export_class (tree ctype)
   else if (lookup_attribute ("dllexport", TYPE_ATTRIBUTES (ctype)))
     import_export = 1;
   else if (CLASSTYPE_IMPLICIT_INSTANTIATION (ctype)
-	   && !flag_implicit_templates)
+	   && !GCC_OPTION (flag_implicit_templates))
     /* For a template class, without -fimplicit-templates, check the
        repository.  If the virtual table is assigned to this
        translation unit, then export the class; otherwise, import
@@ -1852,7 +1852,7 @@ import_export_class (tree ctype)
 	 translation units.  If we were to emit the vtable in each
 	 translation unit containing a definition, we would get
 	 multiple definition errors at link-time.  */
-      if (method && (flag_weak || ! DECL_DECLARED_INLINE_P (method)))
+      if (method && (GCC_OPTION (flag_weak) || ! DECL_DECLARED_INLINE_P (method)))
 	import_export = (DECL_REALLY_EXTERN (method) ? -1 : 1);
     }
 
@@ -1930,7 +1930,7 @@ decl_needed_p (tree decl)
       return true;
   /* Functions marked "dllexport" must be emitted so that they are
      visible to other DLLs.  */
-  if (flag_keep_inline_dllexport
+  if (GCC_OPTION (flag_keep_inline_dllexport)
       && lookup_attribute ("dllexport", DECL_ATTRIBUTES (decl)))
     return true;
   /* Otherwise, DECL does not need to be emitted -- yet.  A subsequent
@@ -2005,7 +2005,7 @@ maybe_emit_vtables (tree ctype)
 
       /* Because we're only doing syntax-checking, we'll never end up
 	 actually marking the variable as written.  */
-      if (flag_syntax_only)
+      if (GCC_OPTION (flag_syntax_only))
 	TREE_ASM_WRITTEN (vtbl) = 1;
       else if (DECL_ONE_ONLY (vtbl))
 	{
@@ -2212,7 +2212,7 @@ determine_visibility (tree decl)
 		determine_visibility_from_class (decl, DECL_CONTEXT (fn));
 	      else if (determine_hidden_inline (fn))
 		{
-		  DECL_VISIBILITY (decl) = default_visibility;
+		  DECL_VISIBILITY (decl) = GCC_OPTION (default_visibility);
 		  DECL_VISIBILITY_SPECIFIED (decl) =
 		    visibility_options.inpragma;
 		}
@@ -2229,7 +2229,7 @@ determine_visibility (tree decl)
 	  use_template = 0;
 	}
       else if (VAR_P (decl) && DECL_TINFO_P (decl)
-	       && flag_visibility_ms_compat)
+	       && GCC_OPTION (flag_visibility_ms_compat))
 	{
 	  /* Under -fvisibility-ms-compat, types are visible by default,
 	     even though their contents aren't.  */
@@ -2267,7 +2267,7 @@ determine_visibility (tree decl)
             {
 	      /* Set default visibility to whatever the user supplied with
 	         #pragma GCC visibility or a namespace visibility attribute.  */
-	      DECL_VISIBILITY (decl) = default_visibility;
+	      DECL_VISIBILITY (decl) = GCC_OPTION (default_visibility);
 	      DECL_VISIBILITY_SPECIFIED (decl) = visibility_options.inpragma;
             }
 	}
@@ -2707,7 +2707,7 @@ import_export_decl (tree decl)
       else if (CLASSTYPE_INTERFACE_KNOWN (class_type)
 	       && CLASSTYPE_INTERFACE_ONLY (class_type))
 	import_p = true;
-      else if ((!flag_weak || TARGET_WEAK_NOT_IN_ARCHIVE_TOC)
+      else if ((!GCC_OPTION (flag_weak) || TARGET_WEAK_NOT_IN_ARCHIVE_TOC)
 	       && !CLASSTYPE_USE_TEMPLATE (class_type)
 	       && CLASSTYPE_KEY_METHOD (class_type)
 	       && !DECL_DECLARED_INLINE_P (CLASSTYPE_KEY_METHOD (class_type)))
@@ -2726,7 +2726,7 @@ import_export_decl (tree decl)
 	{
 	  /* CLASS_TYPE is being exported from this translation unit,
 	     so DECL should be defined here.  */
-	  if (!flag_weak && CLASSTYPE_EXPLICIT_INSTANTIATION (class_type))
+	  if (!GCC_OPTION (flag_weak) && CLASSTYPE_EXPLICIT_INSTANTIATION (class_type))
 	    /* If a class is declared in a header with the "extern
 	       template" extension, then it will not be instantiated,
 	       even in translation units that would normally require
@@ -2758,7 +2758,7 @@ import_export_decl (tree decl)
 		}
 	    }
 	}
-      else if (!flag_implicit_templates
+      else if (!GCC_OPTION (flag_implicit_templates)
 	       && CLASSTYPE_IMPLICIT_INSTANTIATION (class_type))
 	import_p = true;
       else
@@ -2778,7 +2778,7 @@ import_export_decl (tree decl)
 		 that RTTI information will be emitted with the
 		 virtual table of the class, so we must emit it
 		 wherever it is used.  */
-	      && flag_rtti)
+	      && GCC_OPTION (flag_rtti))
 	    import_p = true;
 	  else
 	    {
@@ -2789,7 +2789,7 @@ import_export_decl (tree decl)
 			      || (CLASSTYPE_KEY_METHOD (type)
 				  && DECL_DECLARED_INLINE_P (CLASSTYPE_KEY_METHOD (type))));
 		  mark_needed (decl);
-		  if (!flag_weak)
+		  if (!GCC_OPTION (flag_weak))
 		    {
 		      comdat_p = false;
 		      DECL_EXTERNAL (decl) = 0;
@@ -2806,9 +2806,9 @@ import_export_decl (tree decl)
     {
       /* DECL is an implicit instantiation of a function or static
 	 data member.  */
-      if ((flag_implicit_templates
+      if ((GCC_OPTION (flag_implicit_templates)
 	   && !flag_use_repository)
-	  || (flag_implicit_inline_templates
+	  || (GCC_OPTION (flag_implicit_inline_templates)
 	      && TREE_CODE (decl) == FUNCTION_DECL
 	      && DECL_DECLARED_INLINE_P (decl)))
 	comdat_p = true;
@@ -2828,14 +2828,14 @@ import_export_decl (tree decl)
 	      DECL_NOT_REALLY_EXTERN (decl)
 		= ! (CLASSTYPE_INTERFACE_ONLY (ctype)
 		     || (DECL_DECLARED_INLINE_P (decl)
-			 && ! flag_implement_inlines
+			 && ! GCC_OPTION (flag_implement_inlines)
 			 && !DECL_VINDEX (decl)));
 
 	      if (!DECL_NOT_REALLY_EXTERN (decl))
 		DECL_EXTERNAL (decl) = 1;
 
 	      /* Always make artificials weak.  */
-	      if (DECL_ARTIFICIAL (decl) && flag_weak)
+	      if (DECL_ARTIFICIAL (decl) && GCC_OPTION (flag_weak))
 		comdat_p = true;
 	      else
 		maybe_make_one_only (decl);
@@ -3056,7 +3056,7 @@ get_tls_init_fn (tree var)
 
   /* If -fno-extern-tls-init, assume that we don't need to call
      a tls init function for a variable defined in another TU.  */
-  if (!flag_extern_tls_init && DECL_EXTERNAL (var))
+  if (!GCC_OPTION (flag_extern_tls_init) && DECL_EXTERNAL (var))
     return NULL_TREE;
 
 #ifdef ASM_OUTPUT_DEF
@@ -3557,7 +3557,7 @@ one_static_initialization_or_destruction (tree decl, tree init, bool initp)
 
       /* When using __cxa_atexit, we just check the GUARD as we would
 	 for a local static.  */
-      if (flag_use_cxa_atexit)
+      if (GCC_OPTION (flag_use_cxa_atexit))
 	{
 	  /* When using __cxa_atexit, we never try to destroy
 	     anything from a static destructor.  */
@@ -3599,7 +3599,7 @@ one_static_initialization_or_destruction (tree decl, tree init, bool initp)
 
   /* If we're using __cxa_atexit, we have not already set the GUARD,
      so we must do so now.  */
-  if (guard && initp && flag_use_cxa_atexit)
+  if (guard && initp && GCC_OPTION (flag_use_cxa_atexit))
     finish_expr_stmt (set_guard (guard));
 
   /* Perform the initialization or destruction.  */
@@ -3608,7 +3608,7 @@ one_static_initialization_or_destruction (tree decl, tree init, bool initp)
       if (init)
 	{
 	  finish_expr_stmt (init);
-	  if (flag_sanitize & SANITIZE_ADDRESS)
+	  if (GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS)
 	    {
 	      varpool_node *vnode = varpool_get_node (decl);
 	      if (vnode)
@@ -3618,7 +3618,7 @@ one_static_initialization_or_destruction (tree decl, tree init, bool initp)
 
       /* If we're using __cxa_atexit, register a function that calls the
 	 destructor for the object.  */
-      if (flag_use_cxa_atexit)
+      if (GCC_OPTION (flag_use_cxa_atexit))
 	finish_expr_stmt (register_dtor_fn (decl));
     }
   else
@@ -3663,7 +3663,7 @@ do_static_initialization_or_destruction (tree vars, bool initp)
      in other compilation units, or at least those that haven't been
      initialized yet.  Variables that need dynamic construction in
      the current compilation unit are kept accessible.  */
-  if (flag_sanitize & SANITIZE_ADDRESS)
+  if (GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS)
     finish_expr_stmt (asan_dynamic_init_call (/*after_p=*/false));
 
   node = vars;
@@ -3716,7 +3716,7 @@ do_static_initialization_or_destruction (tree vars, bool initp)
 
   /* Revert what __asan_before_dynamic_init did by calling
      __asan_after_dynamic_init.  */
-  if (flag_sanitize & SANITIZE_ADDRESS)
+  if (GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS)
     finish_expr_stmt (asan_dynamic_init_call (/*after_p=*/true));
 
   /* Finish up the init/destruct if-stmt body.  */
@@ -4267,10 +4267,10 @@ cp_write_global_declarations (void)
   cgraph_process_same_body_aliases ();
 
   /* Handle -fdump-ada-spec[-slim] */
-  if (flag_dump_ada_spec || flag_dump_ada_spec_slim)
+  if (GCC_OPTION (flag_dump_ada_spec) || GCC_OPTION (flag_dump_ada_spec_slim))
     {
-      if (flag_dump_ada_spec_slim)
-	collect_source_ref (main_input_filename);
+      if (GCC_OPTION (flag_dump_ada_spec_slim))
+	collect_source_ref (GCC_OPTION (main_input_filename));
       else
 	collect_source_refs (global_namespace);
 
@@ -4392,7 +4392,7 @@ cp_write_global_declarations (void)
 	     __cxa_atexit, then we don't need to do this; functions
 	     were registered at initialization time to destroy the
 	     local statics.  */
-	  if (!flag_use_cxa_atexit && vars)
+	  if (!GCC_OPTION (flag_use_cxa_atexit) && vars)
 	    {
 	      vars = nreverse (vars);
 	      do_static_initialization_or_destruction (vars, /*initp=*/false);
@@ -4503,7 +4503,7 @@ cp_write_global_declarations (void)
 	      /* If we're compiling -fsyntax-only pretend that this
 		 function has been written out so that we don't try to
 		 expand it again.  */
-	      if (flag_syntax_only)
+	      if (GCC_OPTION (flag_syntax_only))
 		TREE_ASM_WRITTEN (decl) = 1;
 	      reconsider = true;
 	    }
@@ -4600,7 +4600,7 @@ cp_write_global_declarations (void)
   timevar_stop (TV_PHASE_DEFERRED);
   timevar_start (TV_PHASE_OPT_GEN);
 
-  if (flag_vtable_verify)
+  if (GCC_OPTION (flag_vtable_verify))
     {
       vtv_recover_class_info ();
       vtv_compute_class_hierarchy_transitive_closure ();
@@ -4609,7 +4609,7 @@ cp_write_global_declarations (void)
 
   finalize_compilation_unit ();
 
-  if (flag_vtable_verify)
+  if (GCC_OPTION (flag_vtable_verify))
     {
       /* Generate the special constructor initialization function that
          calls __VLTRegisterPairs, and give it a very high
@@ -4648,7 +4648,7 @@ cp_write_global_declarations (void)
      to a file.  */
   dump_tu ();
 
-  if (flag_detailed_statistics)
+  if (GCC_OPTION (flag_detailed_statistics))
     {
       dump_tree_statistics ();
       dump_time_statistics ();
@@ -4760,7 +4760,7 @@ possibly_inlined_p (tree decl)
   gcc_assert (TREE_CODE (decl) == FUNCTION_DECL);
   if (DECL_UNINLINABLE (decl))
     return false;
-  if (!optimize || pragma_java_exceptions)
+  if (!GCC_OPTION (optimize) || pragma_java_exceptions)
     return DECL_DECLARED_INLINE_P (decl);
   /* When optimizing, we might inline everything when flatten
      attribute or heuristics inlining for size or autoinlining
